'' You normally don't need to execute this code, because the disk image is still done
'' and provided in the ZIP file. You need this code to upload modified cpm2 disk images.

{{ Upload CPM disk image to SD card with PropTerminal }}
{{ The file "cpm2.dsk" must exist on the SD card with contiguous sectors. If not,
   just copy an empty file "cpm2.dsk" with 4 MBytes to the SD card with a card reader.
   Size on SD: sourcefile length / 138 * 512 }}

CON
  _clkmode = xtal1 + pll16x     '<-- set here your Oscillator configuration
  _xinfreq = 5_000_000

  SDpin = 8                     '<-- set here your SD card basepin

VAR
  long filename,srcname
  long sect
  byte buffer[16]
  byte sector_buffer[512]

OBJ
    sd   : "fsrw_x1"            'slightly extended FSRW
    ser  : "FullDuplexSerial"

PUB main
  srcname := string("C:\cpm2.dsk")    'Path and Filename of Sourcefile
  filename := string("CPM2.DSK")      'name of the file on SD card
  
  \sd.mount(SDpin)               'Start SD card
  ser.start(31,30,0,115200)      'Serial start

  waitcnt(clkfreq*2+cnt)
  ser.tx(0)
  ser.str(string("Upload File to SD card:",13))
  ser.str(string("Press F1 for start",13))

  repeat until ser.rx == $D0     'wait for F1
  getFile                        'Upload

  ser.str(string(13,"done!",13))
  repeat  


PRI getFile  | b, len, n, i, x, ii, sector_idx, block_number

  ifnot \sd.popen(filename,"r")              'open SD card file
    i := \sd.getVarptr                       'get start sector
    block_number := long[i]<<long[i+48] + long[i+44]
    \sd.pclose
     
    waitcnt(clkfreq/4+cnt)
     
    ser.tx(0)                                'request download sequence:
    ser.str(srcname)                         'send filename
    ser.str(string(5,$82))                   'initiate upload
    ser.tx(strsize(srcname))
    ser.tx("f")
    ser.rxflush  
     
    b := ser.rxtime(100)                     'PropTerm sends first the FileLength (4 bytes)
    if b => 0
      len := b
      b := ser.rxtime(10)  
      len |= b<<8
      b := ser.rxtime(10)  
      len |= b<<16
      b := ser.rxtime(10)  
      len |= b<<24
      
      n := 0                                 'counter for received bytes
      sector_idx := 0                        'index into sector buffer
      ser.tx(".")                            'trigger sending of first 16 bytes
      repeat
        repeat i from 0 to 15                'receive 16 bytes
          b := ser.rxtime(1000)
          if b<0 or n+i==len                 'quit if length reached
            quit
          buffer[i] := b                     'store in buffer
        if b<0
          quit
     
        repeat ii from 0 to 15                  'process the 16 bytes
          sector_buffer[sector_idx] := buffer[ii]
          sector_idx++
          if sector_idx == 137                'Do we have an altair disk sectors worth ?
            x := \sd.WriteSector(block_number, @sector_buffer)   'write the buffer to the SD card
            block_number++
'            outa[16..23] := block_number       'Output the port data
     
            sector_idx := 0
        
        if n+i=>len
          quit
        ser.tx(".")                          'trigger next 16 bytes
        n += 16
     
  else
    ser.str(string("Error: no cpm2.dsk on SD card",13))




    