{{ determine start sector of 'CPM2.DSK' file (CPM disk image) on SD card }}

CON
  _clkmode = xtal1 + pll16x     '<-- set here your Oscillator configuration
  _xinfreq = 5_000_000

  SDpin = 8                     '<-- set here your SD card basepin

OBJ
    sd   : "fsrw_x1"            'slightly extended FSRW
    term : "PC_Text"

PUB main  | i,s
  term.start(12)                 'Start Terminal
  \sd.mount(SDpin)               'Start SD card

  waitcnt(clkfreq+cnt)
  term.out(0)
  term.str(string("Start sector of file 'CPM2.DSK':",13))
  ifnot \sd.popen(string("CPM2.DSK"),"r")    'open SD card file
    i := \sd.getVarptr                       'get start sector
    s := long[i]<<long[i+48] + long[i+44]
    \sd.pclose
    dec(s)                       'disp start sector 
    term.out(13)
  else
    term.str(string("Copy first 'CPM2.DSK' to the SD card",13))
  repeat  


PRI dec(value) | i              '' Print a decimal number

  if value < 0
    -value
    term.out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      term.out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      term.out("0")
    i /= 10
    